unit PainterEffectsU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Buttons, janFX, Menus;


type
  TPainterEffectsF = class(TForm)
    effectspanel: TPanel;
    EBar: TScrollBar;
    extrabar: TScrollBar;
    ETree: TTreeView;
    ScrollBox1: TScrollBox;
    image: TImage;
    SpeedButton1: TSpeedButton;
    cxbar: TScrollBar;
    cybar: TScrollBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    btnappend: TSpeedButton;
    btnstep: TSpeedButton;
    btnstepdown: TSpeedButton;
    procedure EListClick(Sender: TObject);
    procedure EBarChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnappendClick(Sender: TObject);
    procedure btnstepClick(Sender: TObject);
    procedure btnstepdownClick(Sender: TObject);

  private
    procedure bar(max, min, pos: integer);
    { Private declarations }
 procedure contrastbarChange;
 procedure saturationbarChange;
 procedure lightnessbarChange;
 procedure blurbarChange;
 procedure splitblurbarChange;
 procedure colornoisebarChange;
 procedure mononoisebarChange;
 procedure smoothbarChange;
 procedure seambarChange;
 procedure MosaicbarChange;
 procedure TwistbarChange;
 procedure FisheyebarChange;
 procedure wavebarChange;
 procedure waveextraChange;
 procedure waveinfChange;
 procedure rotatebar;
 procedure xformAbarchange ;
 procedure marblebarchange ;
 procedure marble2barchange ;
 procedure marble3barchange ;
 procedure marble4barchange ;
 procedure marble5barchange ;
 procedure marble6barchange ;
 procedure marble7barchange ;
 procedure marble8barchange ;
    procedure Setmaps;
    procedure setimage(var bm: tbitmap);
    procedure aliasbarChange;
    procedure SqueezeHor;
    procedure SqueezeTop;
    procedure SqueezeBottom;
    procedure SqueezeDiamond;
    procedure SqueezeWaste;
    procedure SqueezeRound;
    procedure SqueezeRound2;
    procedure Darkness;
    procedure MaskMandelBrot;
    procedure plasmabarchange;
    procedure mandelFlex;
    procedure drawTriangles;
  public
    { Public declarations }
  Eclip:Tbitmap;
  end;

var
  PainterEffectsF: TPainterEffectsF;

implementation

uses MoviesU;

{$R *.DFM}
var
   src,dst:tbitmap;

procedure TPainterEffectsF.Setmaps;
var h,w:integer;
    R:trect;
begin
h:=Eclip.Height ;
w:=Eclip.Width ;
src.Width :=w;
src.Height :=h;
dst.Width :=w;
dst.Height :=h;
Eclip.PixelFormat :=pf24bit;
src.PixelFormat :=pf24bit;
dst.PixelFormat :=pf24bit;
R:=rect(0,0,w,h);
src.Canvas.copymode:=cmsrccopy;
src.canvas.CopyRect (R,Eclip.canvas,R);
end;

procedure TPainterEffectsF.bar(max,min,pos:integer);
begin
 Ebar.Max :=max;
 Ebar.Min :=min;
 Ebar.Position :=pos;
end;

procedure TPainterEffectsF.EListClick(Sender: TObject);
var index:integer;
begin
if ETree.Selected =nil then exit;
index:=ETree.Selected.ImageIndex ;
if index<0 then exit;
case index of
 0: bar(100,0,0);//contrast
 1: bar(255,0,0);//saturation
 2: bar(100,0,0);//brightness
 3: bar(20,0,0);//gaussian blur
 4: bar(30,0,0);//split blur
 5: bar(200,0,0);//color noise
 6: bar(200,0,0);//mono noise
 7: bar(20,0,0);//smooth
 8: bar(15,3,5);//seamless
 9: bar(30,2,15);//mosaic
 10: bar(50,1,10);//twist
 11: bar(100,55,60);//fisheye
 12: bar(200,1,15);//wave
 13: bar(200,1,15);//wave extra
 14: bar(10,1,1);//wave inference
 15: bar(360,0,0);//smooth rotate
 16: bar(10,1,1);//split light
 17: bar(400,1,1);//wings
 18: bar(400,1,1);//wings down
 19: bar(400,1,1);//wings up
 20: bar(400,1,1);//wings fold
 21: bar(400,1,1);//wings touche
 22: bar(400,1,1);//wings flyer
 23: bar(400,1,1);//wings flipover
 24: bar(400,1,1);//wings wavy
 25: bar(50,1,1);//anti alias
 26: bar(100,0,0);//squeeze hor
 27: bar(100,0,0);//squeeze top
 28: bar(100,0,0);//squeeze bottom
 29: bar(100,0,0);//squeeze diamond
 30: bar(100,0,0);//squeeze waste
 31: bar(100,0,0);//squeeze round
 32: bar(100,0,0);//squeeze round 2
 33: bar(100,0,0);//darkness
 34: bar(64,1,4);//mandelbrot
 35: bar(255,1,1);//plasma
 36: bar(100,0,0);//mandelflex
 37: bar(100,5,15);//triangles
 end;
end;

procedure TPainterEffectsF.EBarChange(Sender: TObject);
var index:integer;
begin
if ETree.selected=nil then exit;
index:=ETree.selected.ImageIndex ;
if index<0 then exit;
case index of
 0: contrastbarChange;
 1: saturationbarChange;
 2: lightnessbarChange;
 3: blurbarChange;
 4: splitblurbarChange;
 5: colornoisebarChange;
 6: mononoisebarChange;
 7: smoothbarChange;
 8: seambarChange;
 9:MosaicbarChange;
 10:TwistbarChange;
 11:FisheyebarChange;
 12:wavebarChange;
 13:waveextraChange;
 14:waveinfChange;
 15:rotatebar;
 16:xformAbarchange ;
 17:marblebarchange ;
 18:marble2barchange ;
 19:marble3barchange ;
 20:marble4barchange ;
 21:marble5barchange ;
 22:marble6barchange ;
 23:marble7barchange ;
 24:marble8barchange ;
 25:aliasbarchange;
 26:squeezehor;
 27:squeezetop;
 28:squeezebottom;
 29:squeezediamond;
 30:squeezewaste;
 31:squeezeround;
 32:squeezeround2;
 33:darkness;
 34:maskmandelbrot;
 35:plasmabarchange;
 36:mandelflex;
 37:drawTriangles;
 end;
end;

procedure TPainterEffectsF.aliasbarChange;
begin
Setmaps;
janFX.AntiAlias(src);
setimage(src);
end;


procedure TPainterEffectsF.blurbarChange;
begin
Setmaps;
janFX.GaussianBlur(src,EBar.position);
setimage(src);
end;

procedure TPainterEffectsF.colornoisebarChange;
begin
Setmaps;
janFX.AddColorNoise(src,EBar.position);
setimage(src);
end;

procedure TPainterEffectsF.contrastbarChange;
begin
Setmaps;
janFX.Contrast(src,EBar.position);
setimage(src);
end;

procedure TPainterEffectsF.FisheyebarChange;
begin
Setmaps;
janFX.Fisheye(src,dst,EBar.position / 100);
setimage(dst);
end;

procedure TPainterEffectsF.lightnessbarChange;
begin
Setmaps;
janFX.Lightness(src,EBar.position);
setimage(src);

end;

procedure TPainterEffectsF.marble2barchange;
begin
Setmaps;
janFX.marble2(src,dst,extrabar.position,ebar.position);
setimage(dst);

end;

procedure TPainterEffectsF.marble3barchange;
begin
Setmaps;
janFX.marble3(src,dst,extrabar.position,ebar.position);
setimage(dst);

end;

procedure TPainterEffectsF.marble4barchange;
begin
Setmaps;
janFX.marble4(src,dst,extrabar.position,ebar.position);
setimage(dst);

end;

procedure TPainterEffectsF.marble5barchange;
begin
Setmaps;
janFX.marble5(src,dst,extrabar.position,ebar.position);
setimage(dst);

end;

procedure TPainterEffectsF.marble6barchange;
begin
Setmaps;
janFX.marble6(src,dst,extrabar.position,ebar.position);
setimage(dst);

end;

procedure TPainterEffectsF.marble7barchange;
begin
Setmaps;
janFX.marble7(src,dst,extrabar.position,ebar.position);
setimage(dst);

end;

procedure TPainterEffectsF.marble8barchange;
begin
Setmaps;
janFX.marble8(src,dst,extrabar.position,ebar.position);
setimage(dst);

end;

procedure TPainterEffectsF.marblebarchange;
begin
Setmaps;
janFX.marble(src,dst,extrabar.position,ebar.position);
setimage(dst);
end;

procedure TPainterEffectsF.mononoisebarChange;
begin
Setmaps;
janFX.AddMonoNoise(src,EBar.position);
setimage(src);

end;

procedure TPainterEffectsF.MosaicbarChange;
begin
Setmaps;
janFX.Mosaic(src,EBar.position);
setimage(src);

end;

procedure TPainterEffectsF.SqueezeHor;
begin
Setmaps;
janFX.squeezehor(src,dst,EBar.position,mbHor);
setimage(dst);
end;

procedure TPainterEffectsF.SqueezeTop;
begin
Setmaps;
janFX.squeezehor(src,dst,EBar.position,mbTop);
setimage(dst);
end;

procedure TPainterEffectsF.Darkness;
begin
Setmaps;
janFX.Darkness(src,EBar.position);
setimage(src);
end;

procedure TPainterEffectsF.mandelFlex;
var xr,yr:extended;
    x0,y0,x1,y1:extended;
begin
Setmaps;
xr:=Ebar.position*0.028;
yr:=ExtraBar.Position*0.009 ;
x0:=-2.25+xr;
x1:=0.75;
y0:=-1.5+yr;
y1:=1.5;
janFX.DrawMandelJulia(src,x0,y0,x1,y1,16,true);
setimage(src);
end;




procedure TPainterEffectsF.SqueezeBottom;
begin
Setmaps;
janFX.squeezehor(src,dst,EBar.position,mbBottom);
setimage(dst);
end;

procedure TPainterEffectsF.SqueezeDiamond;
begin
Setmaps;
janFX.squeezehor(src,dst,EBar.position,mbDiamond);
setimage(dst);
end;

procedure TPainterEffectsF.SqueezeWaste;
begin
Setmaps;
janFX.squeezehor(src,dst,EBar.position,mbwaste);
setimage(dst);
end;

procedure TPainterEffectsF.SqueezeRound;
begin
Setmaps;
janFX.squeezehor(src,dst,EBar.position,mbRound);
setimage(dst);
end;

procedure TPainterEffectsF.SqueezeRound2;
begin
Setmaps;
janFX.squeezehor(src,dst,EBar.position,mbRound2);
setimage(dst);
end;

procedure TPainterEffectsF.rotatebar;
var cx,cy:integer;
begin
Setmaps;
cx:=Eclip.Width div 2;
if cxbar.Position <Eclip.width then
 cx:=cxbar.position;
cy:=Eclip.height div 2;
if cybar.position<Eclip.height then
 cy:=cybar.position;
janFX.SmoothRotate (src,dst,cx,cy,EBar.position);
setimage(dst);
end;

procedure TPainterEffectsF.saturationbarChange;
begin
Setmaps;
janFX.Saturation(src,EBar.position);
setimage(src);

end;

procedure TPainterEffectsF.seambarChange;
begin
Setmaps;
janFX.MakeSeamlessClip(src,EBar.position);
setimage(src);
end;

procedure TPainterEffectsF.smoothbarChange;
begin
Setmaps;
janFX.Smooth(src,EBar.position);
setimage(src);

end;


procedure TPainterEffectsF.plasmabarchange;
var am,turb,w,h:integer;
    src1,src2:tbitmap;
begin
 setmaps;
 w:=Eclip.width;
 h:=Eclip.height;
 src1:=Tbitmap.create;
 src1.width:=w;
 src1.height:=h;
 src1.PixelFormat :=pf24bit;
 src1.canvas.draw(0,0,Eclip);
 src2:=Tbitmap.create;
 src2.width:=w;
 src2.height:=h;
 src2.PixelFormat :=pf24bit;
 src2.canvas.draw(0,0,Eclip);
 am:=painterEffectsF.Ebar.position;
 turb:=painterEffectsF.extrabar.position;
 if turb<10 then begin
  painterEffectsF.extrabar.position:=10;
  turb:=10;
  end;
 janFX.Plasma(src1,src2,src,am,turb);
 setimage(src);
 src2.free;
 src1.free;
end;


procedure TPainterEffectsF.splitblurbarChange;
begin
Setmaps;
janFX.SplitBlur(src,EBar.position);
setimage(src);
end;

procedure TPainterEffectsF.setimage(var bm:tbitmap);
var h,w:integer;
    R:trect;
begin
with image.picture.bitmap do begin
  height:=bm.height;
  width:=bm.width;
  R:=rect(0,0,bm.width,bm.height);
  canvas.CopyRect (R,bm.canvas,r);
//  pixelformat:=pf8bit;
  end;
end;

procedure TPainterEffectsF.TwistbarChange;
begin
Setmaps;
janFX.Twist (src,dst,EBar.position);
setimage(dst);
end;

procedure TPainterEffectsF.wavebarChange;
begin
Setmaps;
janFX.wave (src,EBar.position,0,0);
setimage(src);
end;

procedure TPainterEffectsF.waveextraChange;
begin
Setmaps;
janFX.wave (src,EBar.position,0,1);
setimage(src);
end;

procedure TPainterEffectsF.waveinfChange;
begin
Setmaps;
janFX.wave (src,Extrabar.position,EBar.position,2);
setimage(src);
end;

procedure TPainterEffectsF.xformAbarchange;
begin
Setmaps;
janFX.splitlight(src,EBar.position);
setimage(src);

end;

procedure TPainterEffectsF.FormCreate(Sender: TObject);
begin
Eclip:=tbitmap.Create;
Src:=tbitmap.create;
Dst:=Tbitmap.create;
end;

procedure TPainterEffectsF.SpeedButton1Click(Sender: TObject);
begin
with image.Picture.Bitmap do begin
 width:=Eclip.width;
 height:=Eclip.height;
 end;
modalresult:=mrOK;
end;

procedure TPainterEffectsF.FormDestroy(Sender: TObject);
begin
Eclip.Free;
Src.free;
Dst.free;
end;

procedure TPainterEffectsF.btnappendClick(Sender: TObject);
begin
MoviesF.append;
end;

procedure TPainterEffectsF.btnstepClick(Sender: TObject);
var i,step:integer;

begin
step:=(Ebar.Max-Ebar.min) div TransFrames;
  EBar.position:=Ebar.Min ;
for i:=1 to TransFrames do begin
  EBar.Position := Ebar.Min +i*step;
  btnAppend.Click ;
  end;
end;

procedure TPainterEffectsF.btnstepdownClick(Sender: TObject);
var i,step:integer;

begin
step:=(Ebar.Max-Ebar.min) div TransFrames;
  EBar.position:=Ebar.Max ;
for i:=1 to TransFrames do begin
  EBar.Position := Ebar.Max -i*step;
  btnAppend.Click ;
  end;
end;

procedure TPainterEffectsF.MaskMandelBrot;
begin
Setmaps;
janFX.MaskMandelBrot(src,EBar.position);
setimage(src);
end;

procedure TPainterEffectsF.drawTriangles;
begin
Setmaps;
janFX.Triangles(src, Ebar.position);
setimage(src);
end;

end.
