unit jvFormIni;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,inifiles32;

type
  TjvFormIni = class(TComponent)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    procedure SaveForm(Aform:TForm);
    procedure LoadForm(AForm:TForm);
    procedure Savefont(Acontrol:Tcontrol;AFont:TFont);
    procedure LoadFont(Acontrol:TControl;AFont:Tfont);
    procedure SaveListValues(Asection:string;Alist:tstrings);
    procedure LoadListValues(Asection:string;Alist:tstrings);
    procedure SaveString(section,ident,value:string);
    procedure LoadString(section,ident:string;var value:string);
    procedure SaveBool(section,ident:string;value:boolean);
    procedure LoadBool(section,ident:string;var value:boolean);
    procedure SaveInteger(section,ident:string;value:integer);
    procedure LoadInteger(section,ident:string;var value:integer);
    procedure SaveColor(section,ident:string;value:TColor);
    procedure LoadColor(section,ident:string;var value:Tcolor);

  published
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('jans', [TjvFormIni]);
end;

{ TjvFormIni }





procedure TjvFormIni.LoadBool(section, ident: string; var value: boolean);
var f:TIniFile32;
begin
  f:=TIniFile32.Create (changefileext(application.exename,'.ini'));
  value:=f.ReadBool(section,ident,value);
  f.free;
end;

procedure TjvFormIni.LoadColor(section, ident: string; var value: Tcolor);
var f:TIniFile32;
begin
  try
    f:=TIniFile32.Create (changefileext(application.exename,'.ini'));
    value:=stringtoColor(f.ReadString(section,ident,ColorToString(value)));
  finally
    f.free;
  end;
end;

procedure TjvFormIni.LoadFont(AControl:Tcontrol;AFont: TFont);
var
 f:TIniFile32;
 Str,sc : String;
 I      : byte;
 FFont     : TFont;
Begin
  f:=TIniFile32.Create (changefileext(application.exename,'.ini'));
  Str := f.ReadString(AControl.name,'Font','');
  f.free;
  {read font name}
  I := Pos(',',Str);
  if i = 0 then exit;
  FFont:=tfont.Create ;
  with FFont do begin
    Name := Copy(Str,1,i-1);
    Delete(Str,1,i);
    {read font color}
    i:=Pos(',',Str);
    if i = 0 then begin
      FFont.free;
      exit;
      end;
    try
    Color:= StringtoColor(Copy(Str,1,(i-1)));
    except
    FFont.free;
    exit;
  end;
  Delete(Str,1,i);
  {read font size}
  i:=Pos(',',Str);
  if i = 0 then begin
    FFont.free;
    exit;
    end;
  try
    Size:= StrToInt(Copy(Str,1,(i-1)));
  except
    FFont.free;
    exit;
  end;
  Delete(Str,1,i);
  {read font pitch}
  i:=Pos(',',Str);
  if i = 0 then begin
    FFont.free;
    exit;
    end;
  sc:=Copy(Str,1,(i-1));
  if sc = 'd' then pitch := fpdefault;
  if sc = 'v' then pitch := fpvariable;
  if sc = 'f' then pitch := fpfixed;
  Delete(Str,1,i);
  {read font style}
  Style:=[];
  While length(str)<>0 do
    Begin
      Case Str[1] of
        'b': Style := Style + [fsbold];
        'i': Style := Style + [fsitalic];
        'u': Style := Style + [fsUnderline];
        's': Style := Style + [fsStrikeout];
      end;
      Delete(Str,1,1);
    end;
  end;
  AFont.Assign (Ffont);
  FFont.free;
end;

procedure TjvFormIni.LoadForm(AForm: TForm);
var f:TIniFile32;
    mode:boolean;
begin
 f:=TIniFile32.Create (changefileext(application.exename,'.ini'));
 mode:=f.ReadBool (AForm.name,'State',false);
 with Aform do begin
  if mode then
  windowstate:=wsmaximized
  else begin
   left:=f.ReadInteger (Aform.name,'Left',left);
   top:=f.ReadInteger (Aform.name,'Top',top);
   width:=f.ReadInteger(Aform.name,'Width',width);
   height:=f.ReadInteger(Aform.name,'Height',height);
   end;
  end;
  f.free;
end;


procedure TjvFormIni.LoadInteger(section, ident: string;
  var value: integer);
var f:TIniFile32;
begin
  f:=TIniFile32.Create (changefileext(application.exename,'.ini'));
  value:=f.ReadInteger(section,ident,value);
  f.free;
end;

procedure TjvFormIni.LoadListValues(Asection: string; Alist: tstrings);
var f:TIniFile32;
begin
  f:=TIniFile32.Create (changefileext(application.exename,'.ini'));
  f.ReadSectionValues (Asection,Alist);
  f.free;
end;

procedure TjvFormIni.LoadString(section, ident: string;var value:string);
var f:TIniFile32;
begin
  f:=TIniFile32.Create (changefileext(application.exename,'.ini'));
  value:=f.ReadString(section,ident,value);
  f.free;

end;

procedure TjvFormIni.SaveBool(section, ident: string; value: boolean);
var f:TIniFile32;
begin
  f:=TIniFile32.Create (changefileext(application.exename,'.ini'));
  f.WriteBool(section,ident,value);
  f.free;
end;

procedure TjvFormIni.SaveColor(section, ident: string; value: TColor);
var f:TIniFile32;
begin
  f:=TIniFile32.Create (changefileext(application.exename,'.ini'));
  f.WriteString(section,ident,ColorToString(value));
  f.free;
end;

procedure TjvFormIni.Savefont(Acontrol: Tcontrol;AFont:TFont);
var
 Str :String;
 v :char;
 f:TIniFile32;
Begin
  with AFont do begin
  Str := '';
  Str := Name + ',';
  Str := Str + ColorToString(Color) + ',';
  Str := Str + IntToStr(Size) + ',';
  Case Pitch of
   fpdefault  : v :='d';
   fpvariable : v :='v';
   fpfixed    : v :='f';
  end;
  Str:= Str + v + ',';
  if fsBold in Style then Str:=Str + 'b';
  if fsItalic in Style then Str:=Str + 'i';
  if fsUnderline in Style then Str:=Str + 'u';
  if fsStrikeOut in Style then Str:=Str +'s';
  f:=TIniFile32.Create (changefileext(application.exename,'.ini'));
  f.WriteString(AControl.name,'Font',Str);
  f.free;
  end;
end;

procedure TjvFormIni.SaveForm(Aform: TForm);
var f:TIniFile32;
    mode:boolean;
begin
 f:=TIniFile32.Create (changefileext(application.exename,'.ini'));
 with Aform do begin
  mode:= windowstate=wsmaximized;
  f.WriteBool (Aform.name,'State',mode);
  if not mode then begin
   f.WriteInteger (Aform.name,'Left',left);
   f.WriteInteger (Aform.name,'Top',top);
   f.WriteInteger(Aform.name,'Width',width);
   f.WriteInteger(Aform.name,'Height',height);
  end;
 end;
f.free;
end;


procedure TjvFormIni.SaveInteger(section, ident: string; value: integer);
var f:TIniFile32;
begin
  f:=TIniFile32.Create (changefileext(application.exename,'.ini'));
  f.WriteInteger(section,ident,value);
  f.free;
end;

procedure TjvFormIni.SaveListValues(Asection: string; Alist: tstrings);
var f:TIniFile32;
    i:integer;
begin
 f:=TIniFile32.Create (changefileext(application.exename,'.ini'));
 if Alist.Count >0 then
  for i:=0 to alist.count-1 do
   f.WriteString (asection,alist.names[i],alist.values[alist.names[i]]);
 f.free;
end;

procedure TjvFormIni.SaveString(section, ident, value: string);
var f:TIniFile32;
begin
  f:=TIniFile32.Create (changefileext(application.exename,'.ini'));
  f.WriteString(section,ident,value);
  f.free;
end;

end.
